﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr208_1
{
    class Program
    {
        // Главный метод: 
        unsafe static void Main()
        {
            // Объявление числовой переменной: 
            double miniarray;
            // Размер "byte-массива":
            int m = sizeof(double) / sizeof(byte);
            // Указатель неопределенного типа: 
            void* pnt;
            // Значение указателя: 
            pnt = &miniarray;
            // Указатель на byte-значение: 
            byte* p;
            // Значение указателя: 
            p = (byte*)pnt;
            // Перебор блоков памяти с помощью указателя: 
            for(int k = 0; k < m; k++) {
                // В блок памяти записывается значение: 
                p[k] = (byte)(k + 1);
                // Отображение значения из блока памяти: 
                Console.Write("|" + p[k]);
            }
            Console.WriteLine("|");
            // Новое значение указателя: 
            p = (byte*)pnt + m - 1;
            // Перебор блоков памяти с помощью указателя: 
            for(int k = 0; k < m; k++){
                // Использован отрицательный индекс: 
                Console.Write("|" + p[-k]);
            }
            Console.WriteLine("|");
            // Размер "char-массива":
            int n = sizeof(double) / sizeof(char);
            // Указатель на char-значение: 
            char* q;
            // Значение указателя: 
            q = (char*)pnt;
            // Перебор блоков памяти с помощью указателя: 
            for(int k = 0; k < n; k++){
                // В блок памяти записывается значение: 
                q[k] = (char)('A' + k);
                // Отображение значения из блока памяти:
                Console.Write("|" + q[k]);
            }
            Console.WriteLine("|");
            // Новое значение указателя: 
            q = (char*)pnt + n - 1;
            // Перебор блоков памяти с помощью указателя: 
            for(int k = 0; k < n; k++){
                // Использован отрицательный индекс:
                Console.Write("|" + q[-k]);
            }
            Console.WriteLine("|");
        }
    }
}
